
#ifndef BACKTABRAM_H
#define BACKTABRAM_H

#include "Memory.h"

class BackTabRAM : public Memory
{

    public:
        BackTabRAM();
        void init(INT32 size, INT32 location, INT32 bitWidth);
        ~BackTabRAM();
        void reset();
        INT32 getLocation();
        INT32 peek(INT32 location);
        void poke(INT32 location, INT32 value);
        void markClean();
        BOOL areColorAdvanceBitsDirty();
        BOOL isDirty();
        BOOL isDirty(INT32 location);
        INT32 getSize();
/*
        void save(SaveOutputStream os) throws IOException;
        void load(LoadInputStream is) throws IOException;
*/

    private:
        INT32       size;
        INT32       location;
        INT32       bitWidth;
        INT32       trimmer;
        int*      image;
        BOOL*     dirtyBytes;
        BOOL      dirtyRAM;
        BOOL      colorAdvanceBitsDirty;

};

#endif
