
#ifndef MEMORYBUS_H
#define MEMORYBUS_H

#include "CP1610.h"
#include "Memory.h"

/**
 * Emulates a 16-bit memory map which may be composed of memories of the same
 * size or narrower (10-bit, 8-bit, etc.)
 *
 * @author Kyle Davis
 */
class MemoryBus : public Memory
{

    public:
        MemoryBus();
        MemoryBus(INT32 size);
        ~MemoryBus();
        void init(INT32 size);
        void reset();
        void addMemory(Memory* m);
        void removeMemory(Memory* m);
        INT32 getLocation();
        INT32 peek(INT32 location);
        void poke(INT32 location, INT32 value);
        INT32 getSize();
/*
        void save(SaveOutputStream sos) throws IOException;
        void load(LoadInputStream lis) throws IOException;
*/

    private:
        Memory*  mappedMemories[50];
        INT32    mappedMemoryCount;
        Memory** memory;
        INT32    size;

/*
    //we'll use this for unmapped memory references
    protected Memory unmappedMemory = new Memory() {
            public void reset() {}
            public void save(SaveOutputStream sos) throws IOException {}
            public void load(LoadInputStream lis) throws IOException {}
            public INT32 getSize() {
                return 1;
            }
            public INT32 getLocation() {
                return 0;
            }
            public void poke(INT32 location, INT32 value) {
            }
            public INT32 peek(INT32 location) {
                return UNMAPPED_PEEK;
            }
        };
*/

};

#endif
