
#include <iostream>
#include "ECS.h"

ECS::ECS() {}

ECS::ECS(AudioOutputLine* aol)
{
    init(aol);
}

void ECS::init(AudioOutputLine* aol) {
    this->aol = aol;
    hasECSROM = FALSE;
    init();
}

ECS::~ECS() {
    delete[] memorySegments;
}

INT32 ECS::getProcessorCount() {
    return psg2.getProcessorCount();
}

void ECS::getProcessor(INT32 i, Processor** p) {
    psg2.getProcessor(i, p);
}

INT32 ECS::getMemoryCount() {
    return psg2.getMemoryCount()+5;
}

void ECS::getMemory(INT32 i, Memory** m) {
    (*m) = memorySegments[i];
}

void ECS::setECSROMImage(INT32* ecsImage) {
    bank0.loadImage(ecsImage);
    bank1.loadImage(&ecsImage[0x1000]);
    bank2.loadImage(&ecsImage[0x2000]);
    hasECSROM = TRUE;
}

BOOL ECS::hasECSROMImage()  {
    return hasECSROM;
}

void ECS::setPSGClockDivisor(INT32 divisor) {
    psg2.setClockDivisor(divisor);
}

void ECS::init() {
    psg2.init(aol, 0x00F0, &keyboard, &keyboard);
    INT32 count = psg2.getMemoryCount();
    memorySegments = new Memory*[count + 5];
    for (INT32 i = 0; i < count; i++)
        psg2.getMemory(i, &memorySegments[i]);

    bank0.init(0x1000, 1, 0x2000);
    memorySegments[count] = &bank0;
    bank1.init(0x1000, 0, 0x7000);
    memorySegments[count+1] = &bank1;
    bank2.init(0x1000, 1, 0xE000);
    memorySegments[count+2] = &bank2;

    ramBank.init(0x0800, 0x4000, 8);
    memorySegments[count+3] = &ramBank;

    uart.init(4, 0xE0, 8);
    memorySegments[count+4] = &uart;
}
