
#include "Intellivoice.h"

Intellivoice::Intellivoice() {}

Intellivoice::Intellivoice(AudioOutputLine* aol) {
    init(aol);
}

void Intellivoice::init(AudioOutputLine* aol) {
    hasIvoiceImage = FALSE;
    lpc12.init(aol);
    microSequencer.init(&lpc12);
}

INT32 Intellivoice::getProcessorCount() {
    return 2;
}

void Intellivoice::getProcessor(INT32 i, Processor** p) {
    (*p) = (i == 0 ? (Processor*)&microSequencer : (Processor*)&lpc12);
}

INT32 Intellivoice::getMemoryCount() {
    return 1;
}

void Intellivoice::getMemory(INT32 i, Memory** m) {
    (*m) = &microSequencer.registers;
}

void Intellivoice::setIntellivoiceImage(INT32* image) {
    microSequencer.ivoiceROM.loadImage(image);
    hasIvoiceImage = TRUE;
}

BOOL Intellivoice::hasIntellivoiceImage() {
    return hasIvoiceImage;
}

