
#ifndef INTELLIVOICE_H
#define INTELLIVOICE_H

#include <windows.h>
#include "AudioOutputLine.h"
#include "LPC12.h"
#include "Memory.h"
#include "MicroSequencer.h"
#include "Peripheral.h"
#include "Processor.h"

class Intellivoice : public Peripheral
{

    public:
        Intellivoice();
        Intellivoice(AudioOutputLine* aol);
        void init(AudioOutputLine* aol);
        INT32 getProcessorCount();
        void getProcessor(INT32 i, Processor** p);
        INT32 getMemoryCount();
        void getMemory(INT32 i, Memory** m);
        void setIntellivoiceImage(INT32* image);
        BOOL hasIntellivoiceImage();

    private:
        MicroSequencer microSequencer;
        LPC12          lpc12;
        BOOL           hasIvoiceImage;

};

#endif
