
#ifndef XANADU_H
#define XANADU_H

#include <windows.h>
#include <vector>
#include "Cartridge.h"
#include "CartridgeType.h"
#include "kailleraclient.h"

using namespace std;

int WINAPI startGame(char* game, int player, int numplayers);

typedef struct tagCartridgeFile {
    CartridgeType* cartType;
    char           filename[MAX_PATH];
} CartridgeFile;

class Xanadu
{

    public:
        Xanadu();
        ~Xanadu();
        run(CHAR* lpCmdLine);

        static INT32*     execImage;
        static INT32*     gromImage;
        static INT32*     ecsImage;
        static INT32*     ivoiceImage;

        static const UINT32 CRC_EXECUTIVE_ROM;
        static const UINT32 CRC_GROM;
        static const UINT32 CRC_ECS_ROM;
        static const UINT32 CRC_IVOICE_ROM;
        static const CHAR* FILENAME_EXECUTIVE_ROM;
        static const CHAR* FILENAME_GROM;
        static const CHAR* FILENAME_ECS_ROM;
        static const CHAR* FILENAME_IVOICE_ROM;

        static vector<CartridgeFile*> cartridgeFileList;

    private:
        INT32 playCartridge(Cartridge* cart);
        void scanROMDirectory();
        void clearCartList();

        kailleraInfos kinfos;

};

#endif
