
#include <windows.h>
#include <iostream>
#include <commctrl.h>
#include "Xanadu.h"
#include "XanaduMainWindow.h"
#include "Intellivision.h"
#include "Win32PlugIn.h"
#include "Cartridge.h"
#include "CartridgeType.h"
#include "CartridgeTypeFactory.h"
#include "CRC32.h"
#define KAILLERA_DLL
#include "kailleraclient.h"

#define WM_SHOWSERVERDIALOG WM_APP+1

using namespace std;

WNDCLASSEX XanaduMainWindow::windowClassStruct = {
    sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW, XanaduMainWindowProcedure,
    0L, 0L, GetModuleHandle(NULL), NULL, NULL, (HBRUSH)COLOR_WINDOW,
    NULL, "XanaduMainWindowClass", NULL
};

ATOM XanaduMainWindow::windowClassAtom = RegisterClassEx(&windowClassStruct);

XanaduMainWindow::XanaduMainWindow()
{
    //create the window
    hWnd = CreateWindow(
            XanaduMainWindow::windowClassStruct.lpszClassName, "Xanadu",
            WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE,
            10, 10, 600, 400, NULL, NULL, GetModuleHandle(NULL), NULL);

    InitCommonControls();

    RECT rcl;
    GetClientRect(hWnd, &rcl);
    hTable = CreateWindowEx(WS_EX_CLIENTEDGE, WC_LISTVIEW, "",
            WS_VISIBLE | WS_CHILD | LVS_REPORT | LVS_SINGLESEL |
            LVS_NOSORTHEADER,
            4, 4, rcl.right - rcl.left - 8, rcl.bottom - rcl.top - 8, hWnd, 
            (HMENU)400, GetModuleHandle(NULL), NULL);
    ListView_SetExtendedListViewStyle(hTable, LVS_EX_FULLROWSELECT);

    // Create columns.
    LVCOLUMN lvC;
    lvC.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
    lvC.fmt = LVCFMT_LEFT;
    lvC.cx = 200;
    
    // Load the column labels from the resource file.
    CHAR* columnNames[] = { "Game", "Publisher", "Year" };
    for (INT32 index = 0; index < 3; index++) {
        lvC.iSubItem = index;
        lvC.pszText = columnNames[index];
        ListView_InsertColumn(hTable, index, &lvC);
    }
    
    // Insert items.
    LVITEM lvI;
    lvI.mask = LVIF_TEXT;
    lvI.state = 0;
    lvI.stateMask = 0;
    lvI.pszText = new char[500];
    
    INT32 lsize = Xanadu::cartridgeFileList.size();
    for (INT32 i = 0; i < lsize; i++) {
        lvI.iItem = index;
        lvI.iSubItem = 0;
        lvI.pszText = (char*)Xanadu::cartridgeFileList[i]->cartType->getName();
        ListView_InsertItem(hTable, &lvI);
        lvI.iSubItem = 1;
        lvI.pszText = (char*)Xanadu::cartridgeFileList[i]->cartType->getProducer();
        ListView_SetItem(hTable, &lvI);
        lvI.iSubItem = 2;
        lvI.pszText = (char*)Xanadu::cartridgeFileList[i]->cartType->getYear();
        ListView_SetItem(hTable, &lvI);
    }

    delete[] lvI.pszText;
}

XanaduMainWindow::~XanaduMainWindow()
{
    CloseHandle(hWnd);
}

/*
DWORD WINAPI XanaduMainWindowThread(LPVOID param)
{
    XanaduMainWindow* window = (XanaduMainWindow*)param;

    //create the window
    window->hWnd = CreateWindow(
            XanaduMainWindow::windowClassStruct.lpszClassName, "Xanadu",
            WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN | WS_VISIBLE,
            10, 10, 600, 400, NULL, NULL, GetModuleHandle(NULL), NULL);

    //sync with our window object
    SetEvent(window->syncEvent);

    //start the message pump
    MSG msg;
    while(GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    CloseHandle(window->hWnd);

    //exit the thread
    return msg.wParam;
}
*/

char* tmpGameList = new char[10];
char* tmpAppName = new char[10];
kailleraInfos infos;
LRESULT CALLBACK XanaduMainWindowProcedure(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch(uMsg) {
        case WM_SIZING:
            RECT rcl;
            GetClientRect(hWnd, &rcl);
/*
            SetWindowPos(hTable, 0, 4, 4, rcl.right-rcl.left-8,
                    rcl.bottom-rcl.top-8, SWP_NOOWNERZORDER);
*/
            return 0;

        case WM_DESTROY:
            ShowWindow(hWnd, SW_HIDE);
            PostQuitMessage(0);
            return 0;

        case WM_PAINT:
            ValidateRect(hWnd, NULL);
            return 0;
    };
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

